Hi!

I hope this is the right place to post this bug. I figure it's Node related, so it has to belong in TYPO3CR.

In Neos beta 2 I get an exception when trying to change the order of two nodes in the node tree using drag and drop.

Example:
Content Collection (main) has two nodes below it in the tree:

- Node A
- Node B

If I drag Node B to change the order of the nodes so Node B is before Node A, I get an exception:

13-12-06 18:00:53  CRITICAL  Flow                 Uncaught exception #1301610453 in line 354 of
Data/Temporary/Production/Cache/Code/Flow_Object_Classes/TYPO3_Flow_Mvc_Routing_UriBuilder.php: Could not resolve
a route and its corresponding URI for the given parameters. This may be due to referring to a not existing package / controller /
action while building a link or URI. Refer to log and check the backtrace for more details. - See also:
20131206180051e12226.txt

 20131206180051e12226.txt:

Uncaught exception #1301610453 in line 354 of
Data/Temporary/Production/Cache/Code/Flow_Object_Classes/TYPO3_Flow_Mvc_Routing_UriBuilder.php: Could not resolve
a route and its corresponding URI for the given parameters. This may be due to referring to a not existing package / controller /
action while building a link or URI. Refer to log and check the backtrace for more details.

34 TYPO3\Flow\Mvc\Routing\Router_Original::resolve(array|5|)
33 TYPO3\Flow\Mvc\Routing\UriBuilder_Original::build(array|5|)
32 TYPO3\Flow\Mvc\Routing\UriBuilder_Original::uriFor("show", array|1|, "Frontend\Node", "TYPO3.Neos", NULL)
31 TYPO3\Flow\Mvc\Routing\UriBuilder::uriFor("show", array|1|, "Frontend\Node", "TYPO3.Neos", NULL)
30 call_user_func_array(array|2|, array|5|)
29 TYPO3\Flow\Mvc\Routing\UriBuilder::Flow_Aop_Proxy_invokeJoinPoint(TYPO3\Flow\Aop\JoinPoint)
28 TYPO3\Flow\Aop\Advice\AdviceChain::proceed(TYPO3\Flow\Aop\JoinPoint)
27 TYPO3\Neos\Aspects\PluginUriAspect_Original::rewritePluginViewUris(TYPO3\Flow\Aop\JoinPoint)
26 TYPO3\Flow\Aop\Advice\AroundAdvice::invoke(TYPO3\Flow\Aop\JoinPoint)
25 TYPO3\Flow\Aop\Advice\AdviceChain::proceed(TYPO3\Flow\Aop\JoinPoint)
24 TYPO3\Flow\Mvc\Routing\UriBuilder::uriFor("show", array|1|, "Frontend\Node", "TYPO3.Neos")
23
TYPO3\Neos\Service\ExtDirect\V1\Controller\NodeController_Original::moveAction(TYPO3\TYPO3CR\Domain\Model\Node,
TYPO3\TYPO3CR\Domain\Model\Node, "before")
22 TYPO3\Neos\Service\ExtDirect\V1\Controller\NodeController::moveAction(TYPO3\TYPO3CR\Domain\Model\Node,
TYPO3\TYPO3CR\Domain\Model\Node, "before")
21 call_user_func_array(array|2|, array|3|)
20
TYPO3\Neos\Service\ExtDirect\V1\Controller\NodeController::Flow_Aop_Proxy_invokeJoinPoint(TYPO3\Flow\Aop\JoinPoint)
19 TYPO3\Flow\Aop\Advice\AdviceChain::proceed(TYPO3\Flow\Aop\JoinPoint)
18 TYPO3\Flow\Security\Aspect\PolicyEnforcementAspect_Original::enforcePolicy(TYPO3\Flow\Aop\JoinPoint)
17 TYPO3\Flow\Aop\Advice\AroundAdvice::invoke(TYPO3\Flow\Aop\JoinPoint)
16 TYPO3\Flow\Aop\Advice\AdviceChain::proceed(TYPO3\Flow\Aop\JoinPoint)
15 TYPO3\Neos\Service\ExtDirect\V1\Controller\NodeController::moveAction(TYPO3\TYPO3CR\Domain\Model\Node,
TYPO3\TYPO3CR\Domain\Model\Node, "before")
14 call_user_func_array(array|2|, array|3|)
13 TYPO3\Flow\Mvc\Controller\ActionController_Original::callActionMethod()
12 TYPO3\Flow\Mvc\Controller\ActionController_Original::processRequest(TYPO3\Flow\Mvc\ActionRequest,
TYPO3\ExtJS\ExtDirect\TransactionResponse)
11 TYPO3\Flow\Mvc\Dispatcher_Original::dispatch(TYPO3\Flow\Mvc\ActionRequest,
TYPO3\ExtJS\ExtDirect\TransactionResponse)
10 TYPO3\Flow\Mvc\Dispatcher::dispatch(TYPO3\Flow\Mvc\ActionRequest, TYPO3\ExtJS\ExtDirect\TransactionResponse)
9 call_user_func_array(array|2|, array|2|)
8 TYPO3\Flow\Mvc\Dispatcher::Flow_Aop_Proxy_invokeJoinPoint(TYPO3\Flow\Aop\JoinPoint)
7 TYPO3\Flow\Aop\Advice\AdviceChain::proceed(TYPO3\Flow\Aop\JoinPoint)
6
TYPO3\Flow\Security\Aspect\RequestDispatchingAspect_Original::blockIllegalRequestsAndForwardToAuthenticationEntryPoints(TYPO3\Flow\Aop\JoinPoint)
5 TYPO3\Flow\Aop\Advice\AroundAdvice::invoke(TYPO3\Flow\Aop\JoinPoint)
4 TYPO3\Flow\Aop\Advice\AdviceChain::proceed(TYPO3\Flow\Aop\JoinPoint)
3 TYPO3\Flow\Mvc\Dispatcher::dispatch(TYPO3\Flow\Mvc\ActionRequest, TYPO3\ExtJS\ExtDirect\TransactionResponse)
2 TYPO3\ExtJS\ExtDirect\RequestHandler::handleRequest()
1 TYPO3\Flow\Core\Bootstrap::run()

ts(TYPO3\Flow\Aop\JoinPoint)
5 TYPO3\Flow\Aop\Advice\AroundAdvice::invoke(TYPO3\Flow\Aop\JoinPoint)
4 TYPO3\Flow\Aop\Advice\AdviceChain::proceed(TYPO3\Flow\Aop\JoinPoint)
3 TYPO3\Flow\Mvc\Dispatcher::dispatch(TYPO3\Flow\Mvc\ActionRequest, TYPO3\ExtJS\ExtDirect\TransactionResponse)
2 TYPO3\ExtJS\ExtDirect\RequestHandler::handleRequest()
1 TYPO3\Flow\Core\Bootstrap::run()

Moving nodes from one Content Collection to another appears to work ok.

History
#1 - 2013-12-07 11:47 - Renzo Bauen

Moveing a node works for me, but while publishing, an exception is thrown and the change is not published.

ExtDirect error: Uncaught exception #0 - An exception occurred while executing 'INSERT INTO typo3_typo3cr_domain_model_nodedata
(persistence_object_identifier, pathhash, path, parentpath, identifier, sortingindex, removed, hiddenbeforedatetime, hiddenafterdatetime, properties,
nodetype, hidden, hiddeninindex, accessroles, workspace, contentobjectproxy) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)' with params
["92742fcb-86cd-537e-b4d5-e15fe61ce3fc", "e43f9052837a4c63b1b621350b2b550e", "\/sites\/neosdemotypo3org\/features\/test\/main",
"\/sites\/neosdemotypo3org\/features\/test", "06f314c6-f12d-decc-cab0-570268831749", 100, 0, null, null, "a:0:{}", "TYPO3.Neos:ContentCollection", 0,
0, "a:0:{}", "live", null]: SQLSTATE23000: Integrity constraint violation: 1062 Duplicate entry 'e43f9052837a4c63b1b621350b2b550e-live' for key
'UNIQ_60A956B92DBEC7578D940019'

But as i click the pulldown-menu right of the publish-button, i can go to the workspace-management. When i click there on "Publish all changes" the
change is published as expected. But if i click here to publish the node itself, then the same exception is thrown.
Best Regards Renzo

#2 - 2013-12-07 14:59 - Christian Müller

The bug about the duplicate key is worked on and will be fixed in a few minutes.
The general issue with moving nodes is not clear to us yet. We are trying to pinpoint this as we have had various reports of problems when moving
nodes.

#3 - 2013-12-07 15:02 - Christian Müller

An issue to handle the publishing problem is created here: http://forge.typo3.org/issues/54262
Thanks to Renzo for reporting.
And here is already a fix for it:
https://review.typo3.org/#/c/25994/

#4 - 2013-12-07 17:10 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 5 for branch master of project Packages/TYPO3.Neos has been pushed to the review server.
It is available at https://review.typo3.org/25996

#5 - 2013-12-11 20:29 - Bastian Waidelich
- Status changed from Under Review to Resolved
- Assigned To set to Bastian Waidelich
- % Done changed from 0 to 100

Should have been resolved with https://review.typo3.org/25996
